# TRELLIS.2 Trainer API

> ฝึกอะแดปเตอร์ LoRA สำหรับ Trellis 2 จากไฟล์ zip ที่มีแอสเซ็ต 3D รองรับเดนอยเซอร์ได้สูงสุดสามตัว

ปรับแต่งแอดapter จากไฟล์ zip ที่ `data_url` ซึ่งมีแอสเซ็ต 3D ดิบหรือชุดข้อมูลที่ประมวลผลล่วงหน้า `denoisers` เลือกเป้าหมาย 1 ถึง 3 รายการ โดยแต่ละรายการจะฝึกเป็นแอดapter แยกกัน การตั้งค่า: `resolution` 512 หรือ 1024, `rank` 16, 32 หรือ 64, `learning_rate` และ `training_steps` ตั้งแต่ 100 ถึง 10000 ระบบส่งคืนแอดapter ข้อผิดพลาดที่เกิดขึ้น และข้อมูลที่ประมวลผลล่วงหน้าซึ่งนำกลับมาใช้ได้

- Model id: `trellis-2-lora-trainer`
- Made by: Microsoft
- Category: Training
- Output: file
- Price per run: from $1.7508 / run (cheapest run $1.751 (1751 API credits))
- Run: `POST https://api.doitong.ru/v1/run/trellis-2-lora-trainer`
- Quote: `POST https://api.doitong.ru/v1/quote/trellis-2-lora-trainer`
- Docs page: https://doitong.com/th/developers/models/trellis-2-lora-trainer

## Pricing

Price: **from $1.7508 / run** (the lowest tier; the quote prices your exact input). Price per run: the input files are measured before the run (length, resolution, frame rate). The quote measures the same files and is exactly what the run charges.

The full example input below costs $15.973 = 15973 API credits (1 run × $15.9723).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/trellis-2-lora-trainer` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `data_url` |  | string | yes |  |  | URL ไฟล์เก็บถาวรชุดข้อมูล: ระบุแอสเซ็ต 3D ดิบที่บรรจุเป็น .zip หรือใช้ zip ชุดข้อมูล TRELLIS.2 ที่ประมวลผลล่วงหน้าแล้วซึ่งส่งคืนโดย data_preprocessing |
| `denoisers` |  | array of enum (string) | no |  | 1 – 3 items | การเลือกตัวลดสัญญาณรบกวน TRELLIS.2 ที่แตกต่างกัน 1–3 รายการจาก sparse_structure, geometry และ texture สำหรับการปรับแต่งแบบละเอียด การฝึกแบบขนานใช้ชุดข้อมูลที่ประมวลผลล่วงหน้าร่วมกันเพื่อสร้างอะแดปเตอร์ LoRA แยกกันสำหรับแต่ละรายการที่เลือก |
| `resolution` |  | enum (integer) | no | `512` | `512`, `1024` | ความละเอียดการฝึกต้องเท่ากับความละเอียดการประมวลผลล่วงหน้าของชุดข้อมูล การฝึก geometry และ texture มีการกำหนดค่าแยกกันสำหรับ 512 และ 1024 ขณะที่การฝึก sparse-structure ใช้การกำหนดค่าร่วมกันสำหรับความละเอียดเหล่านี้ |
| `rank` |  | enum (integer) | no | `32` | `16`, `32`, `64` | อันดับของอะแดปเตอร์ LoRA ค่าที่สูงขึ้นจะให้อะแดปเตอร์มีความสามารถมากขึ้น |
| `learning_rate` |  | number | no | `0.0001` | 0.000001 – 0.01 | อัตราการเรียนรู้ที่ใช้ปรับค่า LoRA ให้เหมาะสม |
| `training_steps` |  | integer | no | `1000` | 100 – 10,000 | จำนวนขั้นตอนการฝึกทั้งหมด |

## Example input

Required parameters only:

```json
{
  "data_url": "https://example.com/your-file.zip"
}
```

A fuller example:

```json
{
  "data_url": "https://example.com/your-file.zip"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/trellis-2-lora-trainer?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "data_url": "https://example.com/your-file.zip"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/trellis-2-lora-trainer?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "data_url": "https://example.com/your-file.zip"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "data_url": "https://example.com/your-file.zip",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/trellis-2-lora-trainer", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "trellis-2-lora-trainer",
      "input": {
        "data_url": "https://example.com/your-file.zip"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "trellis-2-lora-trainer",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 15973,
    "usd": "15.973",
    "charged": 15973,
    "refunded": 0
  },
  "input": {
    "data_url": "https://example.com/your-file.zip"
  },
  "output": {
    "adapters": [
      {
        "denoiser": "sparse_structure",
        "resolution": 1,
        "lora_file": {
          "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
          "content_type": "image/jpeg",
          "file_name": "0-output.jpeg",
          "file_size": 1843200
        },
        "rank": 1,
        "training_steps": 1,
        "learning_rate": 1.0
      }
    ],
    "failed": [
      {
        "denoiser": "sparse_structure",
        "error": "string"
      }
    ],
    "preprocessed_data_file": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    }
  },
  "outputs": [
    {
      "type": "file",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `adapters` | array of object {denoiser, resolution, lora_file, rank, training_steps, learning_rate} | ไฟล์อะแดปเตอร์ LoRA ที่จับคู่กับฟิลด์อินเฟอเรนซ์ของ trellis-2-lora ที่เกี่ยวข้อง เอาต์พุตจะมีอะแดปเตอร์หนึ่งรายการสำหรับตัวลดสัญญาณรบกวนแต่ละตัวที่ฝึกสำเร็จ ให้ใช้ไฟล์ของอะแดปเตอร์นั้นในฟิลด์ที่ตรงกัน |
| `failed` | array of object {denoiser, error} | ผลการฝึกตัวลดสัญญาณรบกวนที่ไม่สำเร็จ จะแสดงเฉพาะตัวลดสัญญาณรบกวนที่ฝึกไม่เสร็จที่นี่ ดังนั้นหากตัวลดสัญญาณรบกวนทั้งหมดที่ร้องขอสำเร็จ ค่านี้จะว่างเปล่า |
| `preprocessed_data_file` | object {url, content_type, file_name, file_size} | ไฟล์ zip ชุดข้อมูล TRELLIS.2 ที่ประมวลผลล่วงหน้าแล้ว ซึ่งใช้ระหว่างการฝึกและพร้อมนำกลับมาใช้ใหม่ |

## Related models

- [ERNIE-Image Trainer](https://doitong.com/developers/models/ernie-image-trainer.md) (`ernie-image-trainer`): $0.0012 / step
- [FLUX 2 \[klein\] 9b Base Trainer](https://doitong.com/developers/models/flux-2-klein-9b-base-trainer.md) (`flux-2-klein-9b-base-trainer`): $0.0043 / step
- [Flux 2 Klein 9B Base Trainer](https://doitong.com/developers/models/flux-2-klein-9b-base-trainer/edit.md) (`flux-2-klein-9b-base-trainer/edit`): $0.0139 / step
- [FLUX 2 Trainer](https://doitong.com/developers/models/flux-2-trainer.md) (`flux-2-trainer`): $0.0064 / step
- [FLUX 2 Trainer Edit](https://doitong.com/developers/models/flux-2-trainer/edit.md) (`flux-2-trainer/edit`): $0.0389 / step
- [FLUX 2 Trainer V2](https://doitong.com/developers/models/flux-2-trainer-v2.md) (`flux-2-trainer-v2`): $0.0064 / step
- [FLUX 2 Trainer V2 Edit](https://doitong.com/developers/models/flux-2-trainer-v2/edit.md) (`flux-2-trainer-v2/edit`): $0.0389 / step
- [Flux Kontext Trainer](https://doitong.com/developers/models/flux-kontext-trainer.md) (`flux-kontext-trainer`): from $1.25 / run

## Links

- HTML page: https://doitong.com/developers/models/trellis-2-lora-trainer
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=trellis-2-lora-trainer
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/trellis-2-lora-trainer
